<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from suif1.texi on 28 April 1999 -->

<TITLE>The SUIF Version 1 Library - Overview</TITLE>
<link href="suif1_2.html" rel=Next>
<link href="suif1_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the first, previous, <A HREF="suif1_2.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
<P><HR><P>


<H1><A NAME="SEC1" HREF="suif1_toc.html#TOC1">An Overview of SUIF</A></H1>
<P>
<A NAME="IDX1"></A>
<A NAME="IDX2"></A>

</P>
<P>
The SUIF compiler system is a flexible framework for advanced compiler
research.  The primary design goal for this compiler is that it be easy
to use and build upon, without sacrificing its ability to compile
real-world benchmark programs.  Compared to other publicly-available
compilers, SUIF may be somewhat inefficient and less robust, but it is
much easier to modify and extend.  This makes it an ideal platform for
evaluating new compiler techniques.

</P>
<P>
The SUIF system is organized as a set of compiler passes built on top of
a kernel that defines the intermediate format.  The passes are
implemented as separate programs that link with the kernel contained in
the SUIF library.  Each pass typically performs a single analysis or
transformation and then writes the results out to a file.  This is
inefficient but flexible.  SUIF files always use the same output format
so that passes can be reordered simply by running the programs in a
different order.  New passes can be freely inserted at any point in a
compilation.

</P>
<P>
The SUIF library provides an object-oriented implementation of the SUIF
intermediate format.  It is written in C++.  The library defines classes
to represent all the various elements of the intermediate format and to
perform some common operations on them.  It also contains the code to
read and write the binary files that hold the SUIF code between passes
of the compiler.

</P>
<P>
This document is a reference manual for the SUIF library.  This first
chapter provides an overview of the SUIF intermediate representation.
Like many other complex data structures, this representation is roughly
organized in a hierarchy.  Objects near the top of the hierarchy contain
the lower-level objects.  The various elements of SUIF are described
here starting from the top of the hierarchy and working down.

</P>

<UL>
<LI><A HREF="suif1_2.html#SEC2">File Level</A>: File sets and global symbol tables.
<LI><A HREF="suif1_3.html#SEC3">Procedure Level</A>: Representation of procedure bodies.
<LI><A HREF="suif1_4.html#SEC4">Instruction Level</A>: SUIF instructions and expression trees.
<LI><A HREF="suif1_5.html#SEC5">Symbolic Information</A>: Symbols, types, and symbol tables.
<LI><A HREF="suif1_6.html#SEC6">Other Data</A>: Annotations used to record other information.
</UL>

<P><HR><P>
<p>Go to the first, previous, <A HREF="suif1_2.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
</BODY>
</HTML>
